
// Know the difference between pre and post increment operators

class IntClass
{
   public:
      IntClass(int value);
      // This is the prefix version.
      const IntClass& operator++();

      // This is the postfix version.
      const IntClass IntClass::operator++(int);
      
      // print function
      void print(ostream& out) const;

      // Overload the ++ operator to generate the postfix version.
      operator++(int x)
   protected:
      int theInt_;
};

const IntClass& IntClass::operator++()
{
   ++theInt_;
   return *this;
}

const IntClass IntClass::operator++(int)
{
   IntClass savedValue(*this);
   theInt_++;
   return savedValue;
}


void IntClass::print(ostream& out)
{
   out << "intClass int is " << theInt_ << endl;
}

ostream& operator<<(ostream& out, const IntClass& intClass)
{
   intClass.print(out);
   return out;
}


IntClass::IntClass(int value) : theInt_(value)

int main()
{
   IntClass x(10);
   cout << ++x << endl;  // prints 11
   // The above call causes the compiler to generate:
   // x.operator++()

   cout << x++ << endl;  // prints 11
   // The above call causes the compiler to generate:
   // x.operator++(0)

   cout << x << endl;    // prints 12

   const int N = 10;
   // print the values 0 to n
   int i;
   while(i <= N) cout << i++ << endl;

   // When it doesn't make a difference, prefer ++i to i++.
   //for(int i=0;i<N;i++)
   //{
   //}
   
   //for(int i=0;i<N;++i)
   //{
   //}

   //for(it=container.begin();it != container.end(); ++it)
   //{
   //}
}


   
